Rem
Rem	Saving of actual game with Saitek-OSA-Interace (COM port)
Rem V0.2
Rem

#include "vbcompat.bi"

'
'   Main program
'

DIM As UShort i, n, count
DIM As String indata, dat, fname, cdata
DIM As String actCOM, actBaud, ki
Dim As String Event, Site, GDate, Round, White, Black, Result
Dim xdate As Double = Now()
Dim Shared nParams As UByte
ReDim Shared Param(1 To 2) As String
Dim As String lsd_fil = "PGN files (*.PGN)" + Chr(0) + "*.PGN" + Chr(0)_
+ "All files (*.*)" + Chr(0) + "*.*" + Chr(0, 0)
actCOM = "COM1:"
actBaud = "1200"
Event = "?"
Site = "?"
GDate = Format(xdate, "yyyy.mm.dd") 
Round = "?"
White = "?"
Black = "?"
Result = "*"

' Checking for INI file
If FileExists("osa.ini") Then
    Open "osa.ini" for Input As #4
    Do Until EOF(4)
        Line Input #4, indata
        indata = Trim(indata) : dat = ""
        ' Strip off blanks
        For i = 1 to Len(indata)
            If Mid(indata, i, 1) <> " " Then dat = dat + Mid(indata, i, 1)
        Next i
        If LCase(Left(dat, 4)) = "com=" Then actCOM = Mid(dat, 5)
        If LCase(Left(dat, 5)) = "baud=" Then actBaud = Mid(dat, 6)
    Loop
    Close #4                        
End If

'' Checking for command line parameters
nParams = 0
While Command(nParams + 1) <> ""
    nParams = nParams + 1
Wend
If nParams > 0 Then
    ReDim Param(1 To nParams) As String
    For i = 1 To nParams
        Param(i) = Command(i)
    Next i
End If

WindowTitle "OSA-Save V0.2"
Screen 20,32,1,&H04   ' 1024x768, 128x48, 32 bit palette, no full-screen
Color RGB(0,0,0), RGB(255,255,255)
Cls

#Include once "LoadSaveDialog.inc"

' Help
If UCase(Param(1)) = "/?" Or UCase(Param(1)) = "/H" Then
    Print
    Print "Game saver for Scisys/Saitek chess boards"
    Print "(C) 2012 by Achim Pietig, Version 0.2"
    Print
    Print "Usage: OSA-Save [/?] Or [/h]"
    Print "       OSA-Save filename [COMx:] [baud]"
    Print "Call without parameters 2 and/or 3 sets COM1: with 1200 baud"
    Print "Board shall be set to corresponding baud rate before!"
    Print
    Print "e.g.   OSA-Save game.pgn                (COM1: with 1200 baud)"
    Print "       OSA-Save game.pgn COM2:          (COM2: with 1200 baud)"
    Print "       OSA-Save game.pgn COM3: 9600     (COM3: with 9600 baud)"
    Sleep
    End
End If

' Init program parameters
If nParams = 0 Then
    fname = ""
Else
    fname = Param(1)
    If nParams > 1 Then actCOM = UCase(Param(2))
    If nParams > 2 Then actBaud = Param(3)
End If

If Open Com (actCOM + actbaud + ",N,8,1,CS0,DS0,CD0,RS,BIN" For Binary As #2) <> 0 Then
    Print "Cannot initialise comport"
    Close
    Sleep
    End
End If

Print #2, "ENGLISH"
Sleep 250,1

Print #2, "OPEN"
Do
    dat = Input(1, #2)
    If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
Loop Until dat = Chr(&H17)
Cls
Print "   "; Trim(cdata)
Print

Print #2, "SENDINFO OFF"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

Print "   Running..." : Locate 3, 1
Print #2, "GAME 300"
cdata = ""
Do
    dat = Input(1, #2)
    If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
    If Asc(dat) = 13 Then cdata = cdata + dat
    If Asc(dat) = 10 Then cdata = cdata + dat
Loop Until dat = Chr(&H17)
Sleep 1000, 1

' Flush COM buffer
' Clears the buffer from unnecessary bytes
While LOC(2) > 0
    dat = Input(LOC(2), #2)
Wend

' Release COM port
Print #2, "CLOSE"
Close #2

' Erase en passant notation
While Instr(cdata, "ep")
	i = Instr(cdata, "ep")
	Mid(cdata, i, 2) = "  "
Wend

' Get number of move lines
cdata = Mid(cdata, 5)
count = 0
For i = 1 to Len(cdata)
    If Mid(cdata, i, 1) = "." Then count = count + 1
Next i

' Print move list
Locate 3, 1
If count < 45 Then
    Print cdata;
Else
    i = InStr(cdata, "21.")
    n = InStrRev(cdata, Chr(10), i)
    Print Left(cdata, n);
    Print "  ..."
    dat = Str(count - 22) + "."
    i = InStr(cdata, dat)
    n = InStrRev(cdata, Chr(10), i)
    Print Mid(cdata, n + 1);
End If

' Check game result
If InStrRev(cdata, "1-0") Then Result = "1-0"
If InStrRev(cdata, "0-1") Then Result = "0-1"
If InStrRev(cdata, "1/2-1/2") Then Result = "1/2-1/2"

' Print PGN header
Locate 7, 70 : Print "PGN header:"
Locate 9, 70 : Print "Event:  "; Event
Locate 10, 70 : Print "Site:   "; Site
Locate 11, 70 : Print "Date:   "; GDate 
Locate 12, 70 : Print "Round:  "; Round
Locate 13, 70 : Print "White:  "; White
Locate 14, 70 : Print "Black:  "; Black
Locate 15, 70 : Print "Result: "; Result

' Menu
Locate 35, 70 : Print "(S)ave   (E)dit   (A)bort"

' Check key input
Do
    ki = inkey

    If ki = Chr$(27) Or ki = Chr(255)+"k" Or LCase(ki) = "a" Then
        Close
        End
    End If

    If LCase(ki) = "s" Then
        If fname = "" Then fname = LoadSaveDialog (1, lsd_fil)
        Open fname For Output As #4
        Print #4, "[Event "; Chr(34); Event; Chr(34); "]"
        Print #4, "[Site "; Chr(34); Site; Chr(34); "]"
        Print #4, "[Date "; Chr(34); GDate; Chr(34); "]"
        Print #4, "[Round "; Chr(34); Round; Chr(34); "]"
        Print #4, "[White "; Chr(34); White; Chr(34); "]"
        Print #4, "[Black "; Chr(34); Black; Chr(34); "]"
        Print #4, "[Result "; Chr(34); Result; Chr(34); "]"
        Print #4,
        Print #4, "%OSA notation"
        Print #4, cdata;
        If Result = "*" Then Print #4, Result : Print #4,
        Close
        End
    End If

    If LCase(ki) = "e" Then
        Locate 9, 70 : Line Input "Event:  ", dat
        If dat <> "" Then Event = dat
        Locate 9, 70 : Print "Event:  "; Event
        Locate 10, 70 : Line Input "Site:   ", dat
        If dat <> "" Then Site = dat
        Locate 10, 70 : Print "Site:   "; Site
        Locate 11, 70 : Line Input "Date:   ", dat
        If dat <> "" Then GDate = dat
        Locate 11, 70 : Print "Date:   "; GDate 
        Locate 12, 70 : Line Input "Round:  ", dat
        If dat <> "" Then Round = dat
        Locate 12, 70 : Print "Round:  "; Round
        Locate 13, 70 : Line Input "White:  ", dat
        If dat <> "" Then White = dat
        Locate 13, 70 : Print "White:  "; White
        Locate 14, 70 : Line Input "Black:  ", dat
        If dat <> "" Then Black = dat
        Locate 14, 70 : Print "Black:  "; Black
    End If

Loop
End
